#pragma once
/**
 *	Methods to display height maps in OpenGL.
 *	This includes generating a mesh and saving it as a display list.
 *	It can optionally use an altitude-based color or a single color.
 */


typedef struct _heightmap {
	int size;			//must be 2^n + 1.  We only generate square terrain at present.
	float** heights;	//Holds the heights
	int displayId;		//holds the GL display list id, or zero if not compiled
	double roughness;	//Config setting for roughness used in creating the map. 
						// Value is in (0,1], representing relation between old and new range.
	
	//Stores current generating state.
	int stepLength;		//This represents length of one side of a square at current step.
	float range;		//The current range for moving up/down.
	int square;			//toggle between square and diamond state
	
	float min;			//render calculates this, drawing the water box wants it
} HeightMap;


//Prototypes - Drawing related (algorithm-related ones go in MidPoint.h)
void hmap_draw(HeightMap*);
void hmap_compile(HeightMap*);
void hmap_decompile(HeightMap*);
