#pragma once
#include "MidPoint.h"


typedef struct _thermstate {
	HeightMap *map;		//This is the map we're modifying
	float** next;		//scratch space for the height map's t+1 value
	int T;				//threshhold of altitude difference, calculated from angle of repose for the material
	double C;			//constant between 0 and 1 for how much material moves (percent of height diff)
} ThermalState;


//Prototypes
ThermalState* thermal_create(HeightMap*);	//allocates the space and calls init
int thermal_step(ThermalState*);
void thermal_free(ThermalState*);			//doesn't free the map, since that was made elsewhere
void thermal_print(ThermalState*);