#include <sys/time.h>
#include "Util.h"

static int haveInitializedRandomGenerator = 0;


void** malloc_a2d(int d1, int d2, size_t size) {
	void** p;
	int c;
	
	p = (void**)malloc(d1 * sizeof(void*));
	for(c = 0; c < d1; c++) {
		p[c] = malloc(d2 * size);
	}
	
	return p;
}

void free_a2d(void** p, int d1) {
	int c;
	
	for(c = 0; c < d1; c++) {
		free(p[c]);
	}
	
	free(p);
}

double now() {
	struct timeval tp;
	gettimeofday(&tp, NULL);
	return ((double) tp.tv_sec + (double) tp.tv_usec * 1e-6);
}

float myrand(float range, float min) {
	if( !haveInitializedRandomGenerator ) {
		//srand( (int)(now()*1000) );
		srand(time(0));	//Hmm, I am getting the same sequence of numbers when initializing with this or the previous.
		haveInitializedRandomGenerator = 1;
	}
	
	//double r = drand48();		//I could use this... is it slower by much???
	double r = ((double)rand()) / RAND_MAX;
	return (float)(r*range + min);
}
