/**
 * @author Everett Morse
 * CS 455 Term Project - Obsticle Orb
 * 
 * Load textures
 *	
 */

//C(++) libs
#include <stdio.h>

//Open GL Libs
#include <GLUT/glut.h>
#include <OpenGL/glext.h>
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>

//PNG - Textures
//#include "pngLoad.h"
#include "pixmap.h"
#include "texture.h"


extern GLuint WATER_TEXTURE;
//string textureDir = "texture/";


//From: http://www.macdevcenter.com/pub/a/mac/2005/10/14/texture-maps.html?page=3
int setupGLTexture(unsigned char *image, int width, int height, GLuint texName) 
{
	if (image == NULL)
	{
		return 0;
	}
	printf("(loadTexture) width: %d height: %d\n", width, height); 
	
	/* create a new texture object
	 * and bind it to texname (unsigned integer < 0)
	 */
	glBindTexture(GL_TEXTURE_2D, texName);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, width, height, 0, 
				 GL_RGB, GL_UNSIGNED_BYTE, image);
	return 1;
}

/*
void makeTexture(string filename, GLuint *texNamep) {
	//int result, *width, *height;
	int result;
	unsigned long width, height;
	char *image;
	
	/* read the PNG file using pngLoad 
	 * raw data from PNG file is in image buffer
	 * /
	result = pngLoad((char*)filename.c_str(), &width, &height, &image);
	if (result == 0) {
		printf("(pngLoad) %s FAILED.\n", filename.c_str());
    }* /
	
	
	
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	
	/* Namimg a texture object -see Chapter 9, 
	 * -Red Book
	 * /
	glGenTextures(1, texNamep);
	
	/* take the raw image and put it into an 
	 * OpenGL 2D texture.
	 * /
	setupGLTexture(image, width, height, *texNamep);
}*/

GLuint InitBMPTexture(char * filename, int alphaValue){
	pixmap bmp(filename);	//reads in the bitmap as RGB (no alpha)
	unsigned char* data;
	
	//malloc the space for the data and clear it out
	data = (unsigned char*) malloc(bmp.width * bmp.height * 4);		//4 for the alpha
	memset(data, 0, bmp.width * bmp.height * 4);
	
	//Convert RGB to RGBA
	int x, y;
	for(y = 0; y < bmp.height; y++) {
		for(x = 0; x < bmp.width; x++) {
			int i = 4 * (y * bmp.width + x);
			data[i+0] = bmp.pixel_elem(x,y,pixmap::RED);
			data[i+1] = bmp.pixel_elem(x,y,pixmap::GREEN);
			data[i+2] = bmp.pixel_elem(x,y,pixmap::BLUE);
			data[i+3] = alphaValue; 
		}
	}
	
	//initialize the texture with parameters
	GLuint textureid;
	//*
	glGenTextures(1, &textureid);
	glBindTexture(GL_TEXTURE_2D, textureid); 
	
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP); 
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);//GL_REPEAT
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR); 
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR); 
	
	// Finally we define the 2d texture
	glTexImage2D(GL_TEXTURE_2D,		// texture type. 
				 0,							// level of detail number.  0 means "closest most detailed" 
				 4,							// number of color components in the texture.  We have RGBA that's 4. 
				 bmp.width,			// width of the texture. 
				 bmp.height,		// height of the texture. 
				 0,							// width of the border around the texture.  0 or 1. 
				 GL_RGBA,					// formate of the pixel data is RGBA.
				 GL_UNSIGNED_BYTE,			// data type of the pixel data.  we stored it as bytes. 
				 data);					// pointer to the texture data in memory. 
	
	// And create 2d mipmaps for the minifying function
	gluBuild2DMipmaps(GL_TEXTURE_2D, 4, bmp.width, bmp.height, GL_RGBA, GL_UNSIGNED_BYTE, data);
	//*/
	//setupGLTexture(data, bmp.width, bmp.height, textureid);
	
	return textureid; 
}

void loadTextures() {
	//Load textures (after gl init)
	//makeTexture(textureDir + "water512x512.bmp", &WATER_TEXTURE);
	WATER_TEXTURE = InitBMPTexture( (char*)"texture/water512x512.bmp", 255);
	//WATER_TEXTURE = InitBMPTexture( (char*)"texture/moonmap500x250.bmp", 255);
}
